#line 1 "C:/Users/R-B/Desktop/EmbeddedLab_Code/MikroC_PIC/Clicker2/OLED_W_Raj_V2/OLED.c"


void OLED_M_command(unsigned char temp){
 OLED_CS=0;
 OLED_DC=0;
 SPI1_Write(temp);
 OLED_CS=1;
}

void OLED_M_data(unsigned char temp){
 OLED_CS=0;
 OLED_DC=1;
 SPI1_Write(temp);
 OLED_CS=1;
}

void OLED_M_Init() {
 OLED_RST=0;
 Delay_ms(100);
 OLED_RST=1;
 Delay_ms(100);
 OLED_M_command(SSD1306_DISPLAYOFF);
 OLED_M_command(SSD1306_SETDISPLAYCLOCKDIV);
 OLED_M_command(0x80);
 OLED_M_command(SSD1306_SETMULTIPLEX);
 OLED_M_command(39);
 OLED_M_Command(SSD1306_SETSEGMENTREMAP);
 OLED_M_Command(SSD1306_COMSCANDEC);
 OLED_M_Command(SSD1306_SETSTARTLINE);
 OLED_M_command(SSD1306_SETDISPLAYOFFSET);
 OLED_M_command(0x00);

 OLED_M_command(SSD1306_CHARGEPUMP);
 OLED_M_command(0x14);

 OLED_M_command(SSD1306_SETCOMPINS);
 OLED_M_command(0x12);
 OLED_M_command(SSD1306_SETCONTRAST);
 OLED_M_command(0xAF);
 OLED_M_command(SSD1306_SETPRECHARGE);
 OLED_M_command(0x25);
 OLED_M_command(SSD1306_SETVCOMDETECT);
 OLED_M_command(0x20);
 OLED_M_command(SSD1306_DISPLAYALLON_RESUME);
 OLED_M_command(SSD1306_NORMALDISPLAY);
 OLED_M_command(SSD1306_DISPLAYON);
}






void Set_Page_Address(unsigned char add) {
 add=0xb0|add;
 OLED_M_command(add);
}

void Set_Column_Address(unsigned char add) {
 add += 32;
 OLED_M_command((0x10|(add>>4)));
 OLED_M_command((0x0f&add));
}



void Display_Picture(unsigned char pic[]) {
 unsigned char i,j,num=0;
 for(i=0;i<0x05;i++) {
 Set_Page_Address(i);

 OLED_M_command(0x10);
 OLED_M_command(0x40);
 for(j=0;j<0x60;j++) {
 OLED_M_data(pic[i*0x60+j]);
 }
 }
}

void contrast_control(unsigned char temp){
 OLED_M_command(SSD1306_SETCONTRAST);
 OLED_M_command(temp);
}

void startscroll_Right(unsigned char x, unsigned char y){
 OLED_M_command(SSD1306_RIGHT_HORIZONTAL_SCROLL);
 OLED_M_command(0X00);
 OLED_M_command(x);
 OLED_M_command(0X00);
 OLED_M_command(y);
 OLED_M_command(0X00);
 OLED_M_command(0XFF);
 OLED_M_command(SSD1306_ACTIVATE_SCROLL);
}

void startscroll_Left(unsigned char x, unsigned char y){
 OLED_M_command(SSD1306_LEFT_HORIZONTAL_SCROLL);
 OLED_M_command(0X00);
 OLED_M_command(x);
 OLED_M_command(0X00);
 OLED_M_command(y);
 OLED_M_command(0X00);
 OLED_M_command(0XFF);
 OLED_M_command(SSD1306_ACTIVATE_SCROLL);
}

void startscroll_DiagRight(unsigned char x, unsigned char y){
 OLED_M_command(SSD1306_SET_VERTICAL_SCROLL_AREA);
 OLED_M_command(0X00);
 OLED_M_command(SSD1306_LCDHEIGHT);
 OLED_M_command(SSD1306_VERTICAL_AND_RIGHT_HORIZONTAL_SCROLL);
 OLED_M_command(0X00);
 OLED_M_command(x);
 OLED_M_command(0X00);
 OLED_M_command(y);
 OLED_M_command(0X01);
 OLED_M_command(SSD1306_ACTIVATE_SCROLL);
}

void startscroll_DiagLeft(unsigned char x, unsigned char y){
 OLED_M_command(SSD1306_SET_VERTICAL_SCROLL_AREA);
 OLED_M_command(0X00);
 OLED_M_command(SSD1306_LCDHEIGHT);
 OLED_M_command(SSD1306_VERTICAL_AND_LEFT_HORIZONTAL_SCROLL);
 OLED_M_command(0X00);
 OLED_M_command(x);
 OLED_M_command(0X00);
 OLED_M_command(y);
 OLED_M_command(0X01);
 OLED_M_command(SSD1306_ACTIVATE_SCROLL);
}

void scroll_STOP(){
 OLED_M_command(0x2E);
}

char x, y;

void OLED_Clear( void)
{
 unsigned char i,j;
 for( i=0; i<5; i++)
 {
 Set_Page_Address( i);
 Set_Column_Address( 0);
 for( j=0; j<96; j++) OLED_M_Data( 0);
 }
 x = 0; y = 0;
 Set_Page_Address(0);
 Set_Column_Address(0);
}

void OLED_Putchar( char ch)
{
 unsigned short i;
 const char *f = &font[(ch-' ')*5];
 for( i=0; i<5; i++)
 OLED_M_Data( *f++ << 1);
 OLED_M_Data( 0);
 x++;
 if (x >= 16) {
 x = 0; Set_Column_Address(0);
 y++;
 if (y >= 5) {
 y = 0;
 }
 Set_Page_Address(y);
 }
}

void OLED_Puts( char x1, char y1, char *s)
{
 y = y1; x = x1;
 Set_Page_Address(y);
 Set_Column_Address(x *6);
 while( *s) {
 OLED_Putchar( *s++);
 x++;
 }
}
